Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.h	(revision 224)
@@ -164,7 +164,7 @@
   int8_t _i2caddr, _vccstate, sid, sclk, dc, rst, cs;
 
-  boolean hwSPI;
-  PortReg *mosiport, *clkport, *csport, *dcport;
-  PortMask mosipinmask, clkpinmask, cspinmask, dcpinmask;
+  //boolean hwSPI;
+  //PortReg *mosiport, *clkport, *csport, *dcport;
+  //PortMask mosipinmask, clkpinmask, cspinmask, dcpinmask;
 
   inline void drawFastVLineInternal(int16_t x, int16_t y, int16_t h, uint16_t color) __attribute__((always_inline));
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/BME280.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/BME280.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/BME280.cpp	(revision 224)
@@ -19,4 +19,7 @@
 #include "BME280.h"
 
+#ifdef __SAM3X8E__
+#define Wire Wire1
+#endif
 
 /***************************************************************************
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/CAT9555.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/CAT9555.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/CAT9555.cpp	(revision 224)
@@ -28,4 +28,8 @@
 #include "CAT9555.h"
 #include <Wire.h>
+
+#ifdef __SAM3X8E__
+#define Wire Wire1
+#endif
 
 // CONSTRUCTUR
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.cpp	(revision 224)
@@ -16,40 +16,38 @@
 
 //Constructor
-MAG3110::MAG3110()
-{
-  
-}
-
-
+// MAG3110::MAG3110()
+// {
+// }
 
 // Configure magnetometer
 void MAG3110::begin(void) {
-  //CTRL_REG1
-  //DR2|DR1|DR0|OS1|OS0|FastRead|Trigger|ActiveMode|
-  // 0 | 1 | 1 | 1 | 1 |    0   |   0   |    1     |=dec121
+
   Wire.beginTransmission(MAG_ADDR);// transmit to device 0x0E
-  Wire.write(0x10);                // cntrl register1
-  Wire.write(0x79); // Active Mode, 1.25 Hz datarate, 8x oversampling
-  Wire.endTransmission();          // stop transmitting
+  Wire.write(0x11);              // cntrl register2
+  Wire.write(0x80);              // send 0x80, enable auto resets
+  Wire.endTransmission();       // stop transmitting
   
   delay(15);
   
-  //CTRL_REG2: 
-  //AutoMagRst|---|Raw|Mag_Rst|---|---|---|---|
-  //    1     | 0 | 0 |   0   | 0 | 0 | 0 | 0 |
   Wire.beginTransmission(MAG_ADDR);// transmit to device 0x0E
-  Wire.write(0x11);                // cntrl register2
-  Wire.write(0x80);        // Auto resets before each measurement
-  Wire.endTransmission();          // stop transmitting
+  Wire.write(0x10);              // cntrl register1
+  Wire.write(1);                 // send 0x01, active mode
+  Wire.endTransmission();       // stop transmitting
 }
 
+void MAG3110::read()
+{
+  mag_x =read16Data(0x01,0x02);
+  mag_y =read16Data(0x03,0x04);
+  mag_z =read16Data(0x05,0x06);
+}
+// read X value
 
-// read X value
-int MAG3110::readx(void)
+int MAG3110::read16Data(byte MSB, byte LSB)
 {
   int xl, xh;  //define the MSB and LSB
   
   Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x01);              // x MSB reg
+  Wire.write(MSB);              // x MSB reg
   Wire.endTransmission();       // stop transmitting
  
@@ -65,5 +63,5 @@
   
   Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x02);              // x LSB reg
+  Wire.write(LSB);              // x LSB reg
   Wire.endTransmission();       // stop transmitting
  
@@ -76,77 +74,12 @@
   }
   
-  int xout = (xl|(xh << 8)); //concatenate the MSB and LSB
-  return xout;
+  int out = (xl|(xh << 8)); //concatenate the MSB and LSB 
+  if (out & 0b1000000000000000){
+     //float yout1 = ((~yout & 0b0111111111111111)+ 1)*(-1) ; 
+    return float ((~out & 0b0111111111111111)+ 1)*(-1) ;
+  }
+  return float (out);
 }
 
-//read Y value
-int MAG3110::ready(void)
-{
-  int yl, yh;  //define the MSB and LSB
-  
-  Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x03);              // y MSB reg
-  Wire.endTransmission();       // stop transmitting
- 
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.requestFrom(MAG_ADDR, 1); // request 1 byte
-  while(Wire.available())    // slave may send less than requested
-  { 
-    yh = Wire.read(); // receive the byte
-  }
-  
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x04);              // y LSB reg
-  Wire.endTransmission();       // stop transmitting
- 
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.requestFrom(MAG_ADDR, 1); // request 1 byte
-  while(Wire.available())    // slave may send less than requested
-  { 
-    yl = Wire.read(); // receive the byte
-  }
-  
-  int yout = (yl|(yh << 8)); //concatenate the MSB and LSB
-  return yout;
-}
-
-// read Z value
-int MAG3110::readz(void)
-{
-  int zl, zh;  //define the MSB and LSB
-  
-  Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x05);              // z MSB reg
-  Wire.endTransmission();       // stop transmitting
- 
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.requestFrom(MAG_ADDR, 1); // request 1 byte
-  while(Wire.available())    // slave may send less than requested
-  { 
-    zh = Wire.read(); // receive the byte
-  }
-  
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.beginTransmission(MAG_ADDR); // transmit to device 0x0E
-  Wire.write(0x06);              // z LSB reg
-  Wire.endTransmission();       // stop transmitting
- 
-  delayMicroseconds(2); //needs at least 1.3us free time between start and stop
-  
-  Wire.requestFrom(MAG_ADDR, 1); // request 1 byte
-  while(Wire.available())    // slave may send less than requested
-  { 
-    zl = Wire.read(); // receive the byte
-  }
-  
-  int zout = (zl|(zh << 8)); //concatenate the MSB and LSB
-  return zout;
-}
 
 MAG3110 mag3110;
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MAG3110.h	(revision 224)
@@ -25,14 +25,23 @@
 {
   public:
-    MAG3110();
+    //constructor
+    //MAG3110();
+    
+    //public methods
     void begin();
-    int readx();
-    int ready();
-    int readz();
-	
-	int x(){return readx();};
-	int y(){return ready();};
-	int z(){return readz();};
+    void read(); 
+    int x(){return mag_x;};
+    int y(){return mag_y;};
+    int z(){return mag_z;};
+
   private:
+    //class-only methods:
+    int read16Data(byte MSB, byte LSB);
+    
+    //global variables
+    int mag_x;
+    int mag_y;
+    int mag_z;
+    
 };
 
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MMA8491Q.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MMA8491Q.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/MMA8491Q.cpp	(revision 224)
@@ -30,4 +30,8 @@
 #include "MMA8491Q.h"
 #include <Wire.h>
+
+#ifdef __SAM3X8E__
+#define Wire Wire1
+#endif
 
 // CONSTRUCTUR
Index: rtos_arduino/trunk/arduino_lib/libraries/Servo/src/Servo.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Servo/src/Servo.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Servo/src/Servo.h	(revision 224)
@@ -66,6 +66,8 @@
 #elif defined(ARDUINO_ARCH_SAMD)
 	//#include "samd/ServoTimersSamd.h"
-	#define MIN_PULSE_WIDTH_SAMD 500
-	#define MAX_PULSE_WIDTH_SAMD 2100
+	#define MIN_PULSE_WIDTH_SAMD_TCC 405
+	#define MAX_PULSE_WIDTH_SAMD_TCC 2300
+	#define MIN_PULSE_WIDTH_SAMD_TC 1700
+	#define MAX_PULSE_WIDTH_SAMD_TC 9200
 #else	
 	#error "This library only supports boards with an AVR,SAM or SAMD processor."
Index: rtos_arduino/trunk/arduino_lib/libraries/Servo/src/samd/Servo.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Servo/src/samd/Servo.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Servo/src/samd/Servo.cpp	(revision 224)
@@ -16,4 +16,5 @@
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */
+//Edited by Arduino Srl development team.
 
 #if defined(ARDUINO_ARCH_SAMD)
@@ -22,7 +23,10 @@
 #include <Servo.h>
 
+
 static servo_t servos[MAX_SERVOS];                          // static array of servo structures
 
 uint8_t ServoCount = 0;                                     // the total number of attached servos
+uint8_t isTC = 0 ;
+Tc* TCx ;
 Tcc* TCCx;
 uint8_t Channelx = 0;
@@ -30,6 +34,8 @@
 // convenience macros
 
-#define SERVO_MIN() (MIN_PULSE_WIDTH_SAMD)  // minimum value in uS for this servo
-#define SERVO_MAX() (MAX_PULSE_WIDTH_SAMD)  // maximum value in uS for this servo
+#define SERVO_MIN_TCC() (MIN_PULSE_WIDTH_SAMD_TCC)  // minimum value in uS for this servo if TCC timer is used
+#define SERVO_MAX_TCC() (MAX_PULSE_WIDTH_SAMD_TCC)  // maximum value in uS for this servo if TCC timer is used
+#define SERVO_MIN_TC() (MIN_PULSE_WIDTH_SAMD_TC)  // minimum value in uS for this servo if TC timer is used
+#define SERVO_MAX_TC() (MAX_PULSE_WIDTH_SAMD_TC)  // maximum value in uS for this servo if TC timer is used
 
 /************ static functions common to all instances ***********************/
@@ -46,6 +52,6 @@
   if (ServoCount < MAX_SERVOS) {
     this->servoIndex = ServoCount++;                    // assign a servo index to this instance
-  } else {                                                  //su questo costruttore forse si deve tornare
-    this->servoIndex = INVALID_SERVO;  // too many servos
+  } else {                                                 
+    this->servoIndex = INVALID_SERVO;  					// too many servos
   }
 }
@@ -53,5 +59,10 @@
 uint8_t Servo::attach(int pin)
 {
-  return this->attach(pin, MIN_PULSE_WIDTH_SAMD, MAX_PULSE_WIDTH_SAMD);
+  if((servos[this->servoIndex].Pin.nbr==4) | (servos[this->servoIndex].Pin.nbr==5) | (servos[this->servoIndex].Pin.nbr==10) | (servos[this->servoIndex].Pin.nbr==12) ){
+	return this->attach(pin, SERVO_MIN_TC(), SERVO_MAX_TC());
+  }
+  else{
+	return this->attach(pin, SERVO_MIN_TCC(), SERVO_MAX_TCC());
+  }
 }
 
@@ -63,6 +74,15 @@
     pinMode(pin, OUTPUT);                                   // set servo pin to output
     servos[this->servoIndex].Pin.nbr = pin;
-    if(min > MIN_PULSE_WIDTH_SAMD) min = MIN_PULSE_WIDTH_SAMD;
-	if (max > MAX_PULSE_WIDTH_SAMD) max = MAX_PULSE_WIDTH_SAMD;
+	int servo_min, servo_max;
+	if(pin==4 | pin==5 | pin==10 | pin==12){
+		servo_min=SERVO_MIN_TC();
+		servo_max=SERVO_MAX_TC();
+	}
+	else{
+		servo_min=SERVO_MIN_TCC();
+		servo_max=SERVO_MAX_TCC();
+	}
+    if(min > servo_min) min = servo_min;
+	if (max > servo_max) max = servo_max;
 	this->min  = min;
     this->max  = max;
@@ -75,4 +95,5 @@
 			TCCx=TCC0;
 			Channelx=0;
+			isTC=0;
 		}
 		break;
@@ -83,7 +104,27 @@
 			TCCx=TCC0;
 			Channelx=1;
-		}
-		break;
-		
+			isTC=0;
+		}
+		break;
+
+			case 4:
+		{
+			pinPeripheral(pin, g_APinDescription[pin].ulPinType);
+			TCx=TC3;
+			Channelx=0;
+			isTC=1;
+			 
+		}
+		break;
+
+		case 5:
+		{
+			pinPeripheral(pin, g_APinDescription[pin].ulPinType);
+			TCx=TC3;
+			Channelx=1;
+			isTC=1;
+			 
+		}
+		break;
 		case 6:
 		{
@@ -91,4 +132,5 @@
 			TCCx=TCC0;
 			Channelx=2;
+			isTC=0;
 		}
 		break;
@@ -99,4 +141,5 @@
 			TCCx=TCC0;
 			Channelx=3;
+			isTC=0;
 		}
 		break;
@@ -107,4 +150,5 @@
 			TCCx=TCC1;
 			Channelx=0;
+			isTC=0;
 		}
 		break;
@@ -115,4 +159,15 @@
 			TCCx=TCC1;
 			Channelx=1;
+			isTC=0;
+		}
+		break;
+		
+		case 10:
+		{
+			pinPeripheral(pin, g_APinDescription[pin].ulPinType);
+			TCx=TC3;
+			Channelx=0;
+			isTC=1;
+			 
 		}
 		break;
@@ -123,4 +178,15 @@
 			TCCx=TCC2;
 			Channelx=0;
+			isTC=0;
+		}
+		break;
+		
+		case 12:
+		{
+			pinPeripheral(pin, g_APinDescription[pin].ulPinType);
+			TCx=TC3;
+			Channelx=1;
+			isTC=1;
+			 
 		}
 		break;
@@ -131,4 +197,5 @@
 			TCCx=TCC2;
 			Channelx=1;
+			isTC=0;
 		}
 		break;
@@ -140,10 +207,31 @@
 	
 	if ((TCCx==TCC0) | (TCCx==TCC1)) GCLK->CLKCTRL.reg = (uint16_t) (GCLK_CLKCTRL_CLKEN | GCLK_CLKCTRL_GEN_GCLK3 | GCLK_CLKCTRL_ID( GCM_TCC0_TCC1 )) ;
-	else if(TCCx==TCC2) GCLK->CLKCTRL.reg = (uint16_t) (GCLK_CLKCTRL_CLKEN | GCLK_CLKCTRL_GEN_GCLK3 | GCLK_CLKCTRL_ID( GCM_TCC2_TC3 )) ;
+	else if((TCCx==TCC2) | (TCx==TC3 ))GCLK->CLKCTRL.reg = (uint16_t) (GCLK_CLKCTRL_CLKEN | GCLK_CLKCTRL_GEN_GCLK3 | GCLK_CLKCTRL_ID( GCM_TCC2_TC3 )) ;
 	else;
-		
-	if(servos[this->servoIndex].Pin.isActive == false)
-	{	
-		TCCx->CTRLA.reg &=~(TCC_CTRLA_ENABLE);        //disable TCC module
+
+	if(servos[this->servoIndex].Pin.isActive == false){
+	// Set PORT
+    if ( isTC )
+    {
+      // -- Configure TC
+      //DISABLE TCx
+      TCx->COUNT16.CTRLA.reg &=~(TC_CTRLA_ENABLE);
+      //Set Timer counter Mode to 16 bits
+	  TCx->COUNT16.CTRLA.reg |= TC_CTRLA_MODE_COUNT16;
+	  //Set Prescaler to divide by 2
+	  TCx->COUNT16.CTRLA.reg |= TC_CTRLA_PRESCALER_DIV2;
+      //Set TCx as normal PWM
+      TCx->COUNT16.CTRLA.reg |= TC_CTRLA_WAVEGEN_NPWM;
+	  //default value for servo position
+      TCx->COUNT16.CC[Channelx].reg = 1500;
+	  //ENABLE TCx
+      TCx->COUNT16.CTRLA.reg |= TC_CTRLA_ENABLE;
+	  servos[this->servoIndex].Pin.isActive = true;
+    }
+    else
+    {
+      // -- Configure TCC
+	  
+	 TCCx->CTRLA.reg &=~(TCC_CTRLA_ENABLE);        //disable TCC module
 		TCCx->CTRLA.reg |=TCC_CTRLA_PRESCALER_DIV8;   //setting prescaler to divide by 8
 		TCCx->WAVE.reg |= TCC_WAVE_WAVEGEN_NPWM;      //Set TCCx as normal PWM
@@ -151,8 +239,8 @@
 		TCCx->PER.reg=20000;                          // setting servo frequency (50 hz) 
 		TCCx->CTRLA.reg |= TCC_CTRLA_ENABLE ;	      //ENABLE TCCx
-		servos[this->servoIndex].Pin.isActive = true; 
-	}	
-    
-    //servos[this->servoIndex].Pin.isActive = true;  // this must be set after the check for isTimerActive
+		servos[this->servoIndex].Pin.isActive = true;  
+    }
+	
+	}
   }
   return this->servoIndex;
@@ -167,18 +255,39 @@
   else if((servos[this->servoIndex].Pin.nbr == 8) | (servos[this->servoIndex].Pin.nbr == 9)) TCC1->CTRLA.reg &=~(TCC_CTRLA_ENABLE);
   else if ((servos[this->servoIndex].Pin.nbr == 11) | (servos[this->servoIndex].Pin.nbr == 13)) TCC2->CTRLA.reg &=~(TCC_CTRLA_ENABLE);	
+  else if ((servos[this->servoIndex].Pin.nbr == 4 ) | (servos[this->servoIndex].Pin.nbr == 5 ) | (servos[this->servoIndex].Pin.nbr == 10 ) | (servos[this->servoIndex].Pin.nbr == 12 ))TC3->COUNT16.CTRLA.reg &=~(TC_CTRLA_ENABLE);
 }
 
 void Servo::write(int value)
-{
-  // treat values less than 544 as angles in degrees (valid values in microseconds are handled as microseconds)
-  if (value < MIN_PULSE_WIDTH)
-  {
-    if (value < 0)
-      value = 0;
-    else if (value > 180)
-      value = 180;
-
-    value = map(value, 0, 180, SERVO_MIN(), SERVO_MAX());
-  }
+{  
+  //select the right values for servo motor
+  int servo_min;
+  int servo_max;
+  if((servos[this->servoIndex].Pin.nbr==4) | (servos[this->servoIndex].Pin.nbr==5) | (servos[this->servoIndex].Pin.nbr==10) | (servos[this->servoIndex].Pin.nbr==12) ){
+	servo_min=SERVO_MIN_TC();
+	servo_max=SERVO_MAX_TC();
+	// treat values less than 1700 as angles in degrees (valid values in microseconds are handled as microseconds)
+	if (value < servo_min)
+	{
+		if (value < 0)
+			value = 0;
+		else if (value > 180)
+			value = 180;
+		value = map(value, 0, 180, servo_min, servo_max);
+	}
+  }
+  else{
+	servo_min=SERVO_MIN_TCC();
+	servo_max=SERVO_MAX_TCC();
+	// treat values less than 400 as angles in degrees (valid values in microseconds are handled as microseconds)
+	if (value < servo_min)
+	{
+		if (value < 0)
+			value = 0;
+		else if (value > 180)
+			value = 180;
+		value = map(value, 0, 180, servo_min, servo_max);
+	}
+  }
+    
   writeMicroseconds(value);
 }
@@ -190,9 +299,20 @@
   if( (channel < MAX_SERVOS) )   // ensure channel is valid
   {
-    if (value < SERVO_MIN())          // ensure pulse width is valid
-      value = SERVO_MIN();
-    else if (value > SERVO_MAX())
-      value = SERVO_MAX();
-    servos[this->servoIndex].ticks = value;   //da sistemare
+	//select the right values for servo motor
+	int servo_min;
+	int servo_max;
+	if((servos[this->servoIndex].Pin.nbr==4) | (servos[this->servoIndex].Pin.nbr==5) | (servos[this->servoIndex].Pin.nbr==10) | (servos[this->servoIndex].Pin.nbr==12) ){
+		servo_min=SERVO_MIN_TC();
+		servo_max=SERVO_MAX_TC();
+	}
+	else{
+		servo_min=SERVO_MIN_TCC();
+		servo_max=SERVO_MAX_TCC();
+	}
+    if (value < servo_min)          // ensure pulse width is valid
+      value = servo_min;
+    else if (value > servo_max)
+      value = servo_max;
+    servos[this->servoIndex].ticks = value; 
 	switch(servos[this->servoIndex].Pin.nbr)
 	{
@@ -205,4 +325,12 @@
 			break;
 			
+		case 4:
+			TC3->COUNT16.CC[0].reg = value;
+			break;	
+			
+		case 5:
+			TC3->COUNT16.CC[1].reg = value;
+			break;	
+			
 		case 6:
 			TCC0->CC[2].reg=value;
@@ -220,4 +348,8 @@
 			TCC1->CC[1].reg=value;
 			break;
+		
+		case 10:
+			TC3->COUNT16.CC[0].reg = value;
+			break;		
 			
 		case 11:
@@ -225,4 +357,8 @@
 			break;
 
+		case 12:
+			TC3->COUNT16.CC[1].reg = value;
+			break;	
+
 		case 13:
 			TCC2->CC[1].reg=value;
@@ -234,5 +370,5 @@
 	}
     
-    //servos[this->servoIndex].ticks = value;   //da sistemare
+    //servos[this->servoIndex].ticks = value;   //to be fixed
 	//servos[channel].ticks = value;
   }
@@ -241,5 +377,16 @@
 int Servo::read() // return the value as degrees
 {
-  return map(readMicroseconds(), SERVO_MIN(), SERVO_MAX(), 0, 180);
+  //select the right values for servo motor
+  int servo_min;
+  int servo_max;
+  if((servos[this->servoIndex].Pin.nbr==4) | (servos[this->servoIndex].Pin.nbr==5) | (servos[this->servoIndex].Pin.nbr==10) | (servos[this->servoIndex].Pin.nbr==12) ){
+	servo_min=SERVO_MIN_TC();
+	servo_max=SERVO_MAX_TC();
+	}
+  else{
+	servo_min=SERVO_MIN_TCC();
+	servo_max=SERVO_MAX_TCC();
+	}
+  return map(readMicroseconds(), servo_min, servo_max, 0, 180);
 }
 
Index: rtos_arduino/trunk/lib/Makefile.rca
===================================================================
--- rtos_arduino/trunk/lib/Makefile.rca	(revision 223)
+++ rtos_arduino/trunk/lib/Makefile.rca	(revision 224)
@@ -10,5 +10,5 @@
               wiring.o wiring_digital.o wiring_analog.o wiring_shift.o \
               WInterrupts.o \
-              samd21_device.o samd21_host.o \
+              samd21_host.o \
               dtostrf.o \
               itoa.o \
@@ -110,5 +110,5 @@
 CDEFS += -Dprintf=iprintf \
          -DF_CPU=48000000L \
-         -DARDUINO=10708 \
+         -DARDUINO=10710 \
          -DARDUINO_SAM_ZERO \
          -DARDUINO_ARCH_SAMD \
